package CarTypeRecognition::Error::EMD;

use 5.008001;
use strict;
use warnings;

require Exporter;
use Data::Dumper;

use CarTypeRecognition::Error;

our @ISA = qw(Exporter CarTypeRecognition::Error);
our $VERSION = '0.01';

sub new($$)
{
	my $proto = shift;
	my ( $props ) = @_;

	my $class = ref($proto) || $proto;
	my $self = $class->SUPER::new( $props );
	$self->{'_EMDPRG'}=$props->{'-emd-prog'} || 'compute-SIFT-emd';
	bless ($self, $class);
	return $self;
}

sub get_emdprg($)
{
	return shift->{'_EMDPRG'};
}

sub get_error($$$)
{
	my $self=shift;
	my ( $sift1, $sift2 ) = @_;
	my $emd=$self->get_emdprg();
	

#	print "------------------\n";
#	print Dumper \$sift1;
#	print Dumper \$sift2;
#	print "------------------\n";

	my @errlist=();
	my @copy_sift2=@$sift2;


	my $i=0;
	map {
		my $s1= $_;
		my $s2= shift @copy_sift2;

#		print Dumper $s1;
#		print Dumper $s2;

		my @_t1=@$s1;
		my @_t2=@$s2;

		my $e=undef;
		local *FOUT;
		open FOUT, "> /tmp/emd$$" or die "open(/tmp/emd$$): $!\n";
		print FOUT scalar(@$s1);
		print FOUT " 2\n";
		print FOUT @$s1;
		print FOUT @$s2;
		close FOUT;
		my @_o=`$emd /tmp/emd$$ 2>/dev/null`;
		die "Command ``$emd'' failed with $?\n" if $?;
		for(@_o){
			chomp;
			$e=$1 if /min_e="(.*)"/;
		}
#print "Found error: $e using EMD\n";
		#$s+= (abs($_t1[$_]-$_t2[$_]))**2 for ( 0 .. $#_t1 ) ;
		push( @errlist, $e );
		
		$i++;

	} @$sift1;

	my $err = 0;
	$err+=$_ for @errlist;

	return $err;

}

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

CarTypeRecognition::Main - Perl extension for blah blah blah

=head1 SYNOPSIS

  use CarTypeRecognition::Main;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for CarTypeRecognition::Main, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Mention other useful documentation such as the documentation of
related modules or operating system documentation (such as man pages
in UNIX), or any relevant external documentation such as RFCs or
standards.

If you have a mailing list set up for your module, mention it here.

If you have a web site set up for your module, mention it here.

=head1 AUTHOR

root, E<lt>root@localdomainE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005 by root

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.1 or,
at your option, any later version of Perl 5 you may have available.


=cut
