package CarTypeRecognition::Image;

use 5.008001;
use strict;
use warnings;

require Exporter;
use Image::Magick;
use Data::Dumper;
use File::Basename;

our @ISA = qw(Exporter);
our $VERSION = '0.01';

sub new($$)
{
	my $proto = shift;
	my ( $props ) = @_;

	my $class = ref($proto) || $proto;
	
	my $self  = {
	};

	bless ($self, $class);

	return $self;
}


# Loads image
sub load_image($$)
{
	my $self=shift;
	my ($file)=@_;
	my $I_max=0;
	my $I_min=0xffff;

#print STDERR "load_image(): $file\n";
	if( $file =~ /tif/i ) {
#print STDERR "load_image(): $file is a TIFF image, converting to pgm\n";
		my $b=basename $file;
		$b=~s/tif/pgm/i;
		my $cmd="tifftopnm $file > $b";
#print STDERR "load_image(): exec: |$cmd|\n";
		my $rc=-1;
		for(;$rc;){
			$rc=system $cmd;
			if( $rc != 0 ) {
				print STDERR "load_image(): RC=$rc\n";
				sleep 40;
			}
		}
		$file=$b;
	}	

	my $p = new Image::Magick;
	die "Image::Magick failure" unless defined $p;
	my $w = $p->Read( $file );
	die "$w: $!" if "$w";
	
	my  ( $ow, $oh )  = $p->Get( 'columns', 'rows' );

#	for my $x ( 0 .. $ow ) {
#		for my $y ( 0 .. $oh ) {
#			my ($r,$g,$b,$a)=split(/,/, $p->Get( "pixel[$x,$y]" ));
#			my $Imv = 0.3*$r + 0.6*$g + 0.1*$b;
#			$I_min = $Imv if $Imv < $I_min;
#			$I_max = $Imv if $Imv > $I_max;
#		}
#	}

	return ($p,$ow,$oh);
}

# Get intensity value
sub Iv($$$$)
{
	my $self=shift;
	my ( $p, $x, $y ) = @_;

	my ($r,$g,$b,$a)=split(/,/, $p->Get( "pixel[$x,$y]" ));
	my $Imv = 0.3*$r + 0.6*$g + 0.1*$b;

	$Imv /= 256;
	return $Imv;
}





# Preloaded methods go here.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

CarTypeRecognition::Main - Perl extension for blah blah blah

=head1 SYNOPSIS

  use CarTypeRecognition::Main;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for CarTypeRecognition::Main, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Mention other useful documentation such as the documentation of
related modules or operating system documentation (such as man pages
in UNIX), or any relevant external documentation such as RFCs or
standards.

If you have a mailing list set up for your module, mention it here.

If you have a web site set up for your module, mention it here.

=head1 AUTHOR

root, E<lt>root@localdomainE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005 by root

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.1 or,
at your option, any later version of Perl 5 you may have available.


=cut
