#!/usr/bin/perl

use warnings;
use strict;
use Data::Dumper;
use Chart::Graph::Gnuplot qw(&gnuplot);

use CarTypeRecognition::Classification;
use CarTypeRecognition::SIFT;
use CarTypeRecognition::SIFT::NormalizeGrad;
use CarTypeRecognition::Visualization;


my @graphs=();
my $o=undef;

#	my $sift=CarTypeRecognition::SIFT->new({
#		'-grad-bins'  =>  8,
#		'-boxes-horiz'=>  8,
#		'-boxes-vert' =>  4,
#		'-sift-dir'   => "$ENV{HOME}/.car-recognition/sift",
#		});
#

	my $sift=CarTypeRecognition::SIFT::NormalizeGrad->new({
		'-grad-bins'  =>  9,
		'-boxes-horiz'=>  1,
		'-boxes-vert' =>  1,
		'-sift-dir'   => "$ENV{HOME}/.car-recognition/sift",
		});

	my $v=CarTypeRecognition::Visualization->new( { '-sift' => $sift } );
	$v->visualize_SIFT( $ARGV[0] );

