#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>

#include "files.h"
#include "xfunc.h"

static db_files_t*
get_files_from_filename(char *filename)
{
db_files_t *db_files=xmalloc(sizeof(*db_files));
FILE * fp;
char * line = NULL;
size_t len = 0;
size_t cnt=0;
ssize_t read;
	fp = fopen(filename, "r");
	if (fp == NULL)
		exit(EXIT_FAILURE);
	while ((read = getline(&line, &len, fp)) != -1) {
		if(line){
			char *t=strrchr(line,'\n');
			if(t) *t='\0';
			//printf("Read:|%s|\n", line);
			db_files->db[cnt]=strdup(line);
			cnt++;
		}
	}
	db_files->num_of_files=cnt;
	if (line)
		free(line);
	return db_files;
}

db_files_t *
get_database_files(char *dir)
{
	db_files_t *db_files;
	char findcmd[2048];
	char tmpname[]="dbfiles-XXXXXX";
	if(mkstemp(tmpname)==-1){
		perror("mkstemp()");
		exit(-1);
	}
	sprintf(findcmd, "find %s -type f -print > %s", dir, tmpname);
	if(system(findcmd)){
		perror("system()");
		exit(-1);
	}

	db_files=get_files_from_filename(tmpname);
	
	if(unlink(tmpname)){
		perror("WARNING: unlink()");
	}

	return db_files;
}
